#!/afs/eos.ncsu.edu/lockers/research/ece/wdavis/bin/python
# gen3Dtech for 3DPDK, xchen
# increase the fuction to generate layerDisplay_X.il info (Dec 3)
# modified for FreePDK3D45 (2-tiers) (Mar 2009)
# modified to 5-tiers (Jun 2010)

import re,sys, os

  #input files for Santana.tech
headerfilename = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/header.txt'
layerfilename = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/techdefs.txt'
purposefilename = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/purpose.txt'
viafilename = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/vialayers.txt'
spacefilename = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/spacing.txt'
electfilename = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/electrical.txt'
  #extra input files for FreePDK3D45.tf
controlsfilename = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/controls.txt'
#cdsothersfilename = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/cds_others.txt'
cdsothersfilename = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/cds_others_5.txt'
cdssyspupfilename = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/cds_syspup.txt'
cdssysdisfilename = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/cds_sysdis.txt'

ofilename = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/cni/Santana.tech'
ofilename2 = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/FreePDK3D45.tf'
ofilename3 = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/layerDisplay.il'

header = file(headerfilename, 'r')
src=file(layerfilename,'r')
pup=file(purposefilename, 'r')
via=file(viafilename, 'r')
spa=file(spacefilename, 'r')
elect=file(electfilename, 'r')
control = file(controlsfilename, 'r')
others = file(cdsothersfilename, 'r')
SysLayerPup = file(cdssyspupfilename, 'r')
SysDisplays = file(cdssysdisfilename, 'r')

dest=file(ofilename,'w')
dest2=file(ofilename2,'w')
dest3=file(ofilename3,'w')

suffixes = ('A','B','C','D','E');
#suffixes = ('A','B');
#start from two tiers

layerpup = ('drawing','net','pin','label');

class Layer:
    "Class for creating a layer for the techfile"
    name = ''
    no = ''
    matl = ''
class SysLayer:
    "Class for creating a system reserved layer for the techfile"
    name = ''
    no = ''
class Purpose:
		"Class for creating a purpose layer"
		name = ''
		no = ''
		abbr = ''
class ViaLayer:
		"Class for creating a via layer"
		bottom = ''
		via = ''
		top = ''
class SpacingRule:
		"Class for creating a spacing rule"
		name = ''
		rule = ''
		layer1 = ''
		layer2 = ''
		value = ''
class OrdSpacingRule:
		"Class for creating a ordered spacing rule"
		name = ''
		rule = ''
		layer1 = ''
		layer2 = ''
		value = ''

# define HEADER group
def writeHeader(header,dest):
    for line in header:
        dest.write(line)

def parsefile(src):
    layers = []
    syslayers = []
    reserved = 0
    for line in src:
        x=Layer()
        y=SysLayer()
        ln=line.split()
        if(int(ln[1])<200):
            x.name = ln[0]
            x.no = ln[1]
            x.matl = ln[2]
            layers.append(x)
        elif(int(ln[1])>=200):
            y.name = ln[0]
            y.no = ln[1]
            syslayers.append(y)
    return layers,syslayers

def parsefile2(pup):
		purposes = []
		for line in pup:
			x=Purpose()
			ln=line.split()
			x.name = ln[0]
			x.no = ln[1]
			if (len(ln)>2):
				x.abbr = ln[2]
			purposes.append(x)
		return purposes

def parsefile3(via):
		vias = []
		for line in via:
			x=ViaLayer()
			ln=line.split()
			x.bottom = ln[0]
			x.via = ln[1]
			x.top = ln[2]
			vias.append(x)
		return vias

def parsefile4(spa):
		sparules = []
		ordsparules = []
		for line in spa:
				x=SpacingRule()
				y=OrdSpacingRule()
				ln=line.split()
				if(int(ln[0])==1):
						x.name = ln[1]
						x.rule = ln[2]
						x.layer1 = ln[3]
#						x.layer2 = ' '
						x.value = ln[4]
						sparules.append(x)
				elif(int(ln[0])==2):
						x.name = ln[1]
						x.rule = ln[2]
						x.layer1 = ln[3]
						x.layer2 = ln[4]
						x.value = ln[5]
						sparules.append(x)
				elif(int(ln[0])==3):
						y.name = ln[1]
						y.rule = ln[2]
						y.layer1 = ln[3]
						y.layer2 = ln[4]
						y.value = ln[5]
						ordsparules.append(y)
		return sparules,ordsparules

def writeLayers(dest,layerlist,puplayerlist):
		# define layerMapping
		dest.write(';*******************************\n; LAYER \n;*******************************\n')
		dest.write('layerMapping(\n    ;( name      number )\n    ;( --------  ------ )\n    ;User-Defined Layers:\n')
		dest.write('    ;Universal Layers:\n')
		for layer in layerlist:
				dest.write('     ( ')
				dest.write(layer.name)
				for i in range(10-len(layer.name)):
					dest.write(' ')
#				dest.write(' ')
#				dest.write('\t')
				layerno = str(int(layer.no))		
				dest.write(layerno)
				for i in range(7-len(layerno)):
					dest.write(' ')						
				dest.write(')\n')
		dest.write('\n')
		dest.write('    ;System-Reserved Layers:\n')
		for layer in syslayerlist:
				dest.write('     ( ')
				dest.write(layer.name)
				for i in range(15-len(layer.name)):
					dest.write(' ')
#				dest.write(' ')
#				dest.write('\t')
				dest.write(layer.no)
				for i in range(6-len(layerno)):
					dest.write(' ')
				dest.write(')\n')
		dest.write('\n')
		i = 0
		for tier in suffixes:
				dest.write('    ;Tier_'+tier+' Layers\n')
				for layer in layerlist:
						dest.write('     ( ')
						dest.write(layer.name)
						dest.write('_')
						dest.write(tier)
						for j in range(13-len(layer.name)):
							dest.write(' ')						
#						dest.write('\t')
						if(i==0):
								layerno = str(int(layer.no) + 300)
						else:
#								layerno = str(int(layer.no) + 300 + 200*i)
# change the Tier_offset to 300 in order to be consistent with calibre verification rules, Jun 2010 xchen
								layerno = str(int(layer.no) + 300 + 300*i)
						dest.write(layerno)
						for j in range(7-len(layerno)):
							dest.write(' ')						
						dest.write(')\n')
				dest.write('\n')              
				i = i+1
		dest.write(');layerMapping\n\n')

		# define maskNumbers (No System-Reserved Layers)
		dest.write('maskNumbers(\n    ;( layer     mask   )\n    ;( -----     ----   )\n')
		dest.write('    ;Universal Layers:\n')
		for layer in layerlist:
				dest.write('     ( ')
				dest.write(layer.name)
				for i in range(10-len(layer.name)):
					dest.write(' ')				
#				dest.write(' ')
#				dest.write('\t')
				layerno = str(int(layer.no))
				dest.write(layerno)
				for i in range(7-len(layerno)):
					dest.write(' ')				
				dest.write(')\n')
		dest.write('\n')
		i = 0
		for tier in suffixes:
				dest.write('    ;Tier_'+tier+' Layers\n')
				for layer in layerlist:
						dest.write('     ( ')
						dest.write(layer.name)
						dest.write('_')
						dest.write(tier)
						for j in range(13-len(layer.name)):
							dest.write(' ')					
#						dest.write('\t')
						if(i==0):
								layerno = str(int(layer.no) + 300)
						else:
#								layerno = str(int(layer.no) + 300 +200*i)
# change the Tier_offset to 300 in order to be consistent with calibre verification rules, Jun 2010 xchen
								layerno = str(int(layer.no) + 300 + 300*i)								
						dest.write(layerno)
						for j in range(7-len(layerno)):
							dest.write(' ')						
						dest.write(')\n')
				dest.write('\n')              
				i = i+1
		dest.write(');maskNumbers\n\n')

		# define layerMaterials (No System-Reserved Layers)
		dest.write('layerMaterials(\n    ;( layer     material    )\n    ;( --------  ---------   )\n')
		dest.write('    ;Universal Layers:\n')
		for layer in layerlist:
				dest.write('     ( ')
				dest.write(layer.name)
				for i in range(10-len(layer.name)):
					dest.write(' ')					
#				dest.write(' ')
#				dest.write('\t')
				dest.write(layer.matl)
				for i in range(12-len(layer.matl)):
					dest.write(' ')					
				dest.write(')\n')
		dest.write('\n')
		for tier in suffixes:
				dest.write('    ;Tier_'+tier+' Layers\n')
				for layer in layerlist:
						dest.write('     ( ')
						dest.write(layer.name)
						dest.write('_')
						dest.write(tier)
						for i in range(10-len(layer.name)):
							dest.write(' ')							
#						dest.write('\t')
						dest.write(layer.matl)
						for i in range(12-len(layer.matl)):
							dest.write(' ')							
						dest.write(')\n')
				dest.write('\n')              
		dest.write(');layerMaterials\n\n')

		# define purposeMapping
		dest.write('purposeMapping(\n    ;( name  number )\n    ;( ----  ------ )\n    ;System-Reserved Purposes:\n')
		for layer in puplayerlist:
			if(int(layer.no)<255):
				dest.write('     ( ')
				dest.write(layer.name)
				for i in range(15-len(layer.name)):
					dest.write(' ')					
#				dest.write(' ')
#				dest.write('\t')
				dest.write(layer.no)
				for i in range(7-len(layer.no)):
					dest.write(' ')					
				dest.write(')\n')
		dest.write('\n')
		dest.write(');purposeMapping\n\n')

		# define viaLayers
		dest.write('viaLayers(\n    ;( bottom layer  via layer  top layer )\n    ;( ------------  ---------  --------- )\n')
		for layer in vialayerlist:
				dest.write('     ( ')
				dest.write(layer.bottom)
				for i in range(14-len(layer.bottom)):
					dest.write(' ')
#				dest.write(' ')
#				dest.write('\t\t\t\t')
				dest.write(layer.via)
				for i in range(11-len(layer.via)):
					dest.write(' ')
#				dest.write(' ')
#				dest.write('\t\t\t\t')
				dest.write(layer.top)
				for i in range(10-len(layer.top)):
					dest.write(' ')
				dest.write(')\n')
		for tier in suffixes:
				for layer in vialayerlist:
					if(layer.via!='VTT'):
						dest.write('     ( ')
						dest.write(layer.bottom)
						dest.write('_')
						dest.write(tier)
						for i in range(12-len(layer.bottom)):
							dest.write(' ')
#						dest.write('\t\t\t\t')
						dest.write(layer.via)
						dest.write('_')
						dest.write(tier)
						for i in range(9-len(layer.via)):
							dest.write(' ')
#						dest.write('\t\t\t\t')
						dest.write(layer.top)
						dest.write('_')
						dest.write(tier)
						for i in range(8-len(layer.top)):
							dest.write(' ')
						dest.write(')\n')
					elif(tier!='A'):
						dest.write('     ( ')
						if(tier=='B'):
							dest.write('TM')
						else:
							dest.write(layer.bottom)
						dest.write('_')
						if(tier=='B'):
							dest.write('A')
						elif(tier=='C'):
							dest.write('B')
						elif(tier=='D'):
							dest.write('C')
						else:
							dest.write('D')
						for i in range(12-len(layer.bottom)):
							dest.write(' ')
#						dest.write('\t\t\t\t')
						dest.write(layer.via)
						dest.write('_')
						dest.write(tier)
						for i in range(9-len(layer.via)):
							dest.write(' ')
#						dest.write('\t\t\t\t')
						dest.write(layer.top)
						dest.write('_')
						dest.write(tier)
						for i in range(8-len(layer.top)):
							dest.write(' ')
						dest.write(')\n')
		dest.write('\n')
		dest.write(');viaLayers\n\n')

def writePhysical(dest,sparulelist,ordspalist):
		dest.write(';*******************************\n; PHYSICAL RULES \n;*******************************\n')

		# define spacingRules
		dest.write('spacingRules(\n')
		dest.write(';-------------------ID( rule         layer1   layer2   value )\n')
		dest.write(';---------------------( -----------  -------  -------  ----- )\n')
		for layer in sparulelist:
						for i in range(22-len(layer.name)):
							dest.write(' ')
						dest.write(layer.name+'( ')
						dest.write(layer.rule)
						for i in range(13-len(layer.rule)):
							dest.write(' ')
						dest.write(layer.layer1)
						for i in range(9-len(layer.layer1)):
							dest.write(' ')
						dest.write(layer.layer2)
						for i in range(9-len(layer.layer2)):
							dest.write(' ')
						dest.write(layer.value)
						for i in range(6-len(layer.value)):
							dest.write(' ')
						dest.write(' )\n')
		dest.write('\n')
		for tier in suffixes:
				for layer in sparulelist:
						for i in range(22-len(layer.name)):
							dest.write(' ')
						dest.write(layer.name+'( ')
						dest.write(layer.rule)
						for i in range(13-len(layer.rule)):
							dest.write(' ')
						dest.write(layer.layer1+'_'+tier)
						for i in range(11-len(layer.layer1)):
							dest.write(' ')
						if(layer.layer2):
								dest.write(layer.layer2+'_'+tier)
						else:
								dest.write('  ')
						for i in range(11-len(layer.layer2)):
							dest.write(' ')
#						dest.write('\t\t')
#						dest.write(layer.value+' )\n')
						dest.write(layer.value)
						for i in range(6-len(layer.value)):
							dest.write(' ')
						dest.write(' )\n')
				dest.write('\n')
		dest.write(');spacingRules\n\n')
		
		# define orderedSpacingRules
		dest.write('orderedSpacingRules(\n')
		dest.write(';-------------------------ID( rule            layer1     layer2     value )\n')
		dest.write(';---------------------------( --------------  ---------  ---------  ----- )\n')
		for layer in ordspalist:
						for i in range(28-len(layer.name)):
							dest.write(' ')
						dest.write(layer.name+'( ')
						dest.write(layer.rule)
						for i in range(16-len(layer.rule)):
							dest.write(' ')
						dest.write(layer.layer1)
						for i in range(11-len(layer.layer1)):
							dest.write(' ')
						dest.write(layer.layer2)
						for i in range(11-len(layer.layer2)):
							dest.write(' ')
						dest.write(layer.value)
						for i in range(5-len(layer.value)):
							dest.write(' ')
						dest.write(' )\n')
		dest.write('\n')
		for tier in suffixes:
				for layer in ordspalist:
						for i in range(28-len(layer.name)):
							dest.write(' ')
						dest.write(layer.name+'( ')
						dest.write(layer.rule)
						for i in range(16-len(layer.rule)):
							dest.write(' ')
						dest.write(layer.layer1+'_'+tier)
						for i in range(9-len(layer.layer1)):
							dest.write(' ')
						dest.write(layer.layer2+'_'+tier)
						for i in range(9-len(layer.layer2)):
							dest.write(' ')
						dest.write(layer.value)
						for i in range(5-len(layer.value)):
							dest.write(' ')
						dest.write(' )\n')
				dest.write('\n')
		dest.write(');orderedSpacingRules\n\n')
		
# define electrical rules
def writeElect(elect,dest):
    for line in elect:
#    		ln=line.split()
        dest.write(line)   # same device for every tier

### for cadence techfile generation, Nov 25

# define CONTROLS group
def writeControl(control,dest2):
    for line in control:
        dest2.write(line)

# define LAYER DEFINITION group
def writeLayers2(dest2,layerlist,puplayerlist):
	
		dest2.write(';********************************\n')
		dest2.write('; LAYER DEFINITION\n')
		dest2.write(';********************************\n')
		dest2.write('layerDefinitions(\n\n')
		
		# define techPurposes
		dest2.write('techPurposes(\n')
		dest2.write(' ;( PurposeName               Purpose#   Abbreviation )\n')
		dest2.write(' ;( -----------               --------   ------------ )\n')
		dest2.write(' ;User-Defined Purposes:\n')
		dest2.write(' ;System-Reserved Purposes:\n')
		for layer in puplayerlist:
				dest2.write('  ( ')
				dest2.write(layer.name)
				for i in range(26-len(layer.name)):
					dest2.write(' ')					
				dest2.write(layer.no)
				for i in range(11-len(layer.no)):
					dest2.write(' ')					
				dest2.write(layer.abbr)
				for i in range(13-len(layer.abbr)):
					dest2.write(' ')				
				dest2.write(')\n')
#		dest2.write('\n')
		dest2.write(' ) ;techPurposes\n\n')

		# define techLayerPurposePriorities
		dest2.write(' techLayerPurposePriorities(\n')
		dest2.write(' ;( LayerName      Purpose )\n')
		dest2.write(' ;( ---------      ------- )\n')
		for layer in layerlist:
			for lpup in layerpup:
				dest2.write('  ( ')
				dest2.write(layer.name)
				for i in range(15-len(layer.name)):
					dest2.write(' ')				
				dest2.write(lpup)
				for i in range(8-len(lpup)):
					dest2.write(' ')				
				dest2.write(')\n')
		dest2.write('\n')
		i = 0
		for tier in suffixes:
				dest2.write('  ;Tier_'+tier+' LayerPurposePriorities\n')
				for layer in layerlist:
					for lpup in layerpup:
						dest2.write('  ( ')
						dest2.write(layer.name)
						dest2.write('_')
						dest2.write(tier)
						for j in range(13-len(layer.name)):
							dest2.write(' ')
						dest2.write(lpup)					
						for j in range(8-len(lpup)):
							dest2.write(' ')						
						dest2.write(')\n')
				dest2.write('\n')              
				i = i+1
		i = 0
#		add system layer into FreePDK3D45.tf, xchen Aug 12 09
		dest2.write('  ;System LayerPurposePriorities\n')
		for line in SysLayerPup:
			dest2.write(line)
		dest2.write('\n')
		dest2.write(' ) ;techLayerPurposePriorities\n\n')
		
		# define techDisplays
		dest2.write(' techDisplays(\n')
		dest2.write(' ;( LayerName    Purpose      Packet          Vis Sel Con2ChgLy DrgEnbl Valid )\n')
		dest2.write(' ;( ---------    -------      ------          --- --- --------- ------- ----- )\n')
		for lpup in layerpup:
			for layer in layerlist:
				dest2.write('  ( ')
				dest2.write(layer.name)								
				for i in range(13-len(layer.name)):
					dest2.write(' ')									
				dest2.write(lpup)
				for i in range(13-len(lpup)):
					dest2.write(' ')
				dest2.write(layer.name)
				for i in range(16-len(layer.name)):
					dest2.write(' ')
				if (lpup=='drawing'):
					dest2.write(' t   t      t        t      t  ')
# added scripts for layerDisplay_X.il file, Dec 3
					dest3.write('			   (list  '+'\''+'(')  
					dest3.write('"'+layer.name+'"')		  
					for i in range(13-len(layer.name)):
						dest3.write(' ')	  
					dest3.write('"'+lpup+'")  t  t  t  )\n')         
					if (layer.matl=='metal'):                        	
						dest3.write('			   (list  '+'\''+'("'+layer.name+'"')
						for i in range(13-len(layer.name)):
							dest3.write(' ')
						dest3.write('"pin"    )  t  t  t  )\n')
						dest3.write('			   (list  '+'\''+'("'+layer.name+'"')
						for i in range(13-len(layer.name)):
							dest3.write(' ')
						dest3.write('"label"  )  t  t  t  )\n')
# end of scripts												
				elif (lpup=='net'):
					dest2.write(' nil nil    nil      nil    nil')
				else:
					if (layer.matl=='metal'):
						dest2.write(' t   t      t        t      t  ')
					else:
						dest2.write(' nil nil    nil      nil    nil')								
				dest2.write(' )\n')	
		dest2.write('\n')
		for tier in suffixes:
			dest2.write('  ;Tier_'+tier+' techDisplays\n')
			for lpup in layerpup:
				for layer in layerlist:
					dest2.write('  ( ')
					dest2.write(layer.name+'_'+tier)
					for i in range(11-len(layer.name)):
						dest2.write(' ')				
					dest2.write(lpup)
					for i in range(13-len(lpup)):
						dest2.write(' ')
#  use different display packets for layers at different tiers, Dec 1
#					dest2.write(layer.name+'_'+tier)
#					for i in range(14-len(layer.name)):
					dest2.write(layer.name)
					for i in range(16-len(layer.name)):
						dest2.write(' ')
					if (lpup=='drawing'):
						dest2.write(' t   t      t        t      t  ')
# added scripts for layerDisplay_X.il file, Dec 3
						dest3.write('			   (list  '+'\''+'(')  
						dest3.write('"'+layer.name+'_'+tier+'"')		  
						for i in range(11-len(layer.name)):
							dest3.write(' ')	  
						dest3.write('"'+lpup+'")  t  t  t  )\n')         
						if (layer.matl=='metal'):                        	
							dest3.write('			   (list  '+'\''+'("'+layer.name+'_'+tier+'"')
							for i in range(11-len(layer.name)):
								dest3.write(' ')
							dest3.write('"pin"    )  t  t  t  )\n')
							dest3.write('			   (list  '+'\''+'("'+layer.name+'_'+tier+'"')
							for i in range(11-len(layer.name)):
								dest3.write(' ')
							dest3.write('"label"  )  t  t  t  )\n')
# end of scripts						
					elif (lpup=='net'):
						dest2.write(' nil nil    nil      nil    nil')
					else:
						if (layer.matl=='metal'):
							dest2.write(' t   t      t        t      t  ')
						else:
							dest2.write(' nil nil    nil      nil    nil')								
					dest2.write(' )\n')
			dest2.write('\n')
# add system layer display, xchen Aug 13 09
		dest2.write('  ;System layer techDisplays\n')
		for line in SysDisplays:
			dest2.write(line)
		dest2.write('\n')		
# end of system layer display		
		dest2.write(' ) ;techDisplays\n\n')
		
		# define techLayerProperties
		dest2.write(' techLayerProperties(\n')
		dest2.write(' ;( PropName               Layer1 [ Layer2 ]            PropValue )\n')
		dest2.write(' ;( --------               ------ ----------            --------- )\n')
		dest2.write('\n')
		dest2.write(' ) ;techLayerProperties\n\n')
		
		# define techDerivedLayers
		dest2.write(' techDerivedLayers(\n')
		dest2.write(' ;( DerivedLayerName          #          composition  )\n')
		dest2.write(' ;( ----------------          ------     ------------ )\n')
		dest2.write('\n')
		dest2.write(' ) ;techDerivedLayers\n\n')				
		
		dest2.write(') ;layerDefinitions\n\n')

# define other groups in cadence techfile
def writeOthers(others,dest2):
    for line in others:
        dest2.write(line)

# define leRules in cadence techfile, Dec 3
def writeLeRules(layerlist,dest2):
		dest2.write(';********************************\n')
		dest2.write('; LE RULES\n')
		dest2.write(';********************************\n')
		dest2.write('leRules(\n\n')
		dest2.write(' leLswLayers(\n')
		dest2.write('    ;( layer         purpose  )\n')
		dest2.write('    ;( -----         -------  )\n')
		# refer to layerDisplay.il generation, Dec 3
		for layer in layerlist:
#				if (lpup=='drawing'):
					dest2.write('     ( ')  
					dest2.write(layer.name)		  
					for i in range(14-len(layer.name)):
						dest2.write(' ')	  
					dest2.write('drawing  )\n')					         
					if (layer.matl=='metal'):                        	
						dest2.write('     ( '+layer.name)
						for i in range(14-len(layer.name)):
							dest2.write(' ')
						dest2.write('pin      )\n')
						dest2.write('     ( '+layer.name)
						for i in range(14-len(layer.name)):
							dest2.write(' ')
						dest2.write('label    )\n')
		dest2.write('\n')
		for tier in suffixes:
			dest2.write('  ;Tier_'+tier+' leRules\n')
			for layer in layerlist:
						dest2.write('     ( ')  
						dest2.write(layer.name+'_'+tier)		  
						for i in range(12-len(layer.name)):
							dest2.write(' ')	  
						dest2.write('drawing  )\n')         
						if (layer.matl=='metal'):                        	
							dest2.write('     ( '+layer.name+'_'+tier)
							for i in range(12-len(layer.name)):
								dest2.write(' ')
							dest2.write('pin      )\n')
							dest2.write('     ( '+layer.name+'_'+tier)
							for i in range(12-len(layer.name)):
								dest2.write(' ')
							dest2.write('label    )\n')
			dest2.write('\n')			
		dest2.write(' ) ;leLswLayers\n\n')
		dest2.write(') ;leRules\n')
		
(layerlist,syslayerlist) = parsefile(src)
(puplayerlist) = parsefile2(pup)
(vialayerlist) = parsefile3(via)
(sparulelist,ordspalist) = parsefile4(spa)

# save HEADER group
writeHeader(header,dest)
writeLayers(dest,layerlist,puplayerlist)
writePhysical(dest,sparulelist,ordspalist)
writeElect(elect,dest)

writeControl(control,dest2)
writeLayers2(dest2,layerlist,puplayerlist)
writeOthers(others,dest2)
writeLeRules(layerlist,dest2)
