#!/afs/eos.ncsu.edu/lockers/research/ece/wdavis/bin/python
###################################################
#
# gentech.py
#
# Created 1/3/2007 by Rhett Davis (rhett_davis@ncsu.edu)
# Redirect to /ncsu_basekit (Mar 2009, xchen)
#
#####################################################

import sshaft, os, sys, testproc

sshaft.beginstep('gentech.py')

# Parse arguments
args=sys.argv[1:]
while (len(args)>0):
    arg=args[0]
    args=args[1:]
    sshaft.logf('LOG_WARN',"WARNING: Unrecognized argument "+arg)


libname='NCSU_TechLib_FreePDK3D45'
path=os.environ['PDK_DIR']+'/ncsu_basekit/lib/'+libname
filename=os.environ['PDK_DIR']+'/ncsu_basekit/techfile/cni/Santana.tech'
if os.access(path,os.F_OK):
    sshaft.logf('LOG_INFO',"Deleting "+path)
    os.system('rm -rf '+path)
if os.access("run/cds",os.F_OK):
    sshaft.logf('LOG_INFO',"Deleting run/cds")
    os.system('rm -rf run/cds')
sshaft.verify_dir(os.environ['PDK_DIR']+'/ncsu_basekit/lib')

sshaft.substep(mode='unix_prog', cmd='gen3Dtech.py >& gen3Dtech.log')
#cmd='cngenlib -c --techfile '+filename+' tech:only  '+libname+' '+path+' >& cngenlib.log'
cmd='cngenlib -c --techfile '+filename+' pkg:pycells  '+libname+' '+path+' >& cngenlib.log'
# add devices pycells; Sept 05, 09 xchen

sshaft.substep(mode='unix_prog', cmd=cmd, env='cadence')
sshaft.dir_init('run/cds','cds')
sshaft.substep(mode='cds_step', cmd='pdkAppendTechfile()', rundir='run/cds')

#sshaft.copy_file(os.environ['PDK_DIR']+'/techfile/'+libname+'.layermap',
#                 os.environ['PDK_DIR']+'/lib/'+libname+'/'+libname+'.layermap')

#sshaft.substep(mode='unix_prog', cmd='lefin -lef ../../../techfile/'+libname+
#               '_3d.lef -lib temptech -libPath ./temptech >& lefin.log',
#               rundir='run/cds',env='cadence')

#sshaft.substep(mode='unix_prog', cmd='cnpy '+os.environ['SSHAFT_HOME']+
#               '/src/py/load3DLef.py temptech '+libname+' >& load3DLef.log',
#               rundir='run/cds',env='cadence')

viadir = os.environ['PDK_DIR']+'/ncsu_basekit/techfile/customvia/*'
cmd = 'cp -r '+viadir+' '+path
sshaft.substep(mode='unix_prog',cmd=cmd)

sshaft.endstep()
