################################################################################
################################################################################
#                                                                              #
# Copyright (c) 2001-2006 CiraNova, Inc. All Rights Reserved.                  #
#                                                                              #
# Permission is hereby granted, free of charge, to any person obtaining a copy #
# of this software and associated documentation ("CiraNova Open Code"), to use #
# the CiraNova Open Code without restriction, including without limitation the #
# right to use, copy, modify, merge, publish, distribute, sublicense, and sell #
# copies of the CiraNova Open Code, and to permit persons to whom the CiraNova #
# Open Code is furnished to do so, subject to the following conditions:        #
#                                                                              #
# The above copyright notice and this permission notice must be included in    #
# all copies and all distribution, redistribution, and sublicensing of the     #
# CiraNova Open Code. THE CIRANOVA OPEN CODE IS PROVIDED "AS IS" AND WITHOUT   #
# WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR STATUTORY INCLUDING WITHOUT        #
# LIMITATION ANY WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR         #
# PURPOSE, TITLE AND NONINFRINGEMENT. IN NO EVENT SHALL CIRANOVA, INC. BE      #
# LIABLE FOR ANY INDIRECT, PUNITIVE, SPECIAL, INCIDENTAL OR CONSEQUENTIAL      #
# DAMAGES ARISING FROM, OUT OF OR IN CONNECTION WITH THE CIRANOVA OPEN CODE    #
# OR ANY USE OF THE CIRANOVA OPEN CODE, OR BE LIABLE FOR ANY CLAIM, DAMAGES OR #
# OTHER LIABILITY, HOWEVER IT ARISES AND ON ANY THEORY OF LIABILITY, WHETHER   #
# IN AN ACTION FOR CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE),  #
# OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE CIRANOVA OPEN   #
# CODE OR ANY USE OF THE CIRANOVA OPEN CODE. The CiraNova Open Code is subject #
# to U.S. export control laws and may be subject to export or import           #
# regulations in other countries, and all use of the CiraNova Open Code must   #
# be in compliance with such laws and regulations.  If any license for the     #
# CiraNova Open Code is obtained pursuant to a government contract, all use,   #
# distribution and/or copying by the U.S. government shall be subject to this  #
# permission notice and any applicable FAR provisions.                         #
#                                                                              #
################################################################################
################################################################################


import Mosfet_vtl
import Mosfet_vtl_A
import Mosfet_vtl_B
import Mosfet_vtl_C
import Mosfet_vtl_D
import Mosfet_vtl_E
import Mosfet_vtg
import Mosfet_vtg_A
import Mosfet_vtg_B
import Mosfet_vtg_C
import Mosfet_vtg_D
import Mosfet_vtg_E
import Mosfet_vth
import Mosfet_vth_A
import Mosfet_vth_B
import Mosfet_vth_C
import Mosfet_vth_D
import Mosfet_vth_E
import Mosfet_thkox
import Mosfet_thkox_A
import Mosfet_thkox_B
import Mosfet_thkox_C
import Mosfet_thkox_D
import Mosfet_thkox_E
import Via
import Via_A
import Via_B
import Via_C
import Via_D
import Via_E
import transistorUnit
#import diffPair

def definePcells(lib):
#     lib.definePcell(Via.Via1,          "via1"        )
#     lib.definePcell(Via.Via2,          "via2"        )
#     lib.definePcell(Via.Via3,          "via3"        )
#     lib.definePcell(Via.NwellContact,  "nwcont"      )
#     lib.definePcell(Via.PwellContact,  "pwcont"      )
     lib.definePcell(Via.NdiffContact,  "ndcont"      )
     lib.definePcell(Via.PdiffContact,  "pdcont"      )
     lib.definePcell(Via.DiffContact,   "dcont"       )
     lib.definePcell(Via.PolyContact,   "pcont"       )
     lib.definePcell(Via_A.NdiffContact_A,  "ndcont_A"      )
     lib.definePcell(Via_A.PdiffContact_A,  "pdcont_A"      )
     lib.definePcell(Via_A.DiffContact_A,   "dcont_A"       )
     lib.definePcell(Via_A.PolyContact_A,   "pcont_A"       )
     lib.definePcell(Via_B.NdiffContact_B,  "ndcont_B"      )
     lib.definePcell(Via_B.PdiffContact_B,  "pdcont_B"      )
     lib.definePcell(Via_B.DiffContact_B,   "dcont_B"       )
     lib.definePcell(Via_B.PolyContact_B,   "pcont_B"       )
     lib.definePcell(Via_C.NdiffContact_C,  "ndcont_C"      )
     lib.definePcell(Via_C.PdiffContact_C,  "pdcont_C"      )
     lib.definePcell(Via_C.DiffContact_C,   "dcont_C"       )
     lib.definePcell(Via_C.PolyContact_C,   "pcont_C"       )
     lib.definePcell(Via_D.NdiffContact_D,  "ndcont_D"      )
     lib.definePcell(Via_D.PdiffContact_D,  "pdcont_D"      )
     lib.definePcell(Via_D.DiffContact_D,   "dcont_D"       )
     lib.definePcell(Via_D.PolyContact_D,   "pcont_D"       )
     lib.definePcell(Via_E.NdiffContact_E,  "ndcont_E"      )
     lib.definePcell(Via_E.PdiffContact_E,  "pdcont_E"      )
     lib.definePcell(Via_E.DiffContact_E,   "dcont_E"       )
     lib.definePcell(Via_E.PolyContact_E,   "pcont_E"       )
     lib.definePcell(Mosfet_vtl.Nmos_vtl,       "nmos_vtl"        )
     lib.definePcell(Mosfet_vtl.Pmos_vtl,       "pmos_vtl"        )
     lib.definePcell(Mosfet_vtl_A.Nmos_vtl_A,       "nmos_vtl_A"        )
     lib.definePcell(Mosfet_vtl_A.Pmos_vtl_A,       "pmos_vtl_A"        )
     lib.definePcell(Mosfet_vtl_B.Nmos_vtl_B,       "nmos_vtl_B"        )
     lib.definePcell(Mosfet_vtl_B.Pmos_vtl_B,       "pmos_vtl_B"        )
     lib.definePcell(Mosfet_vtl_C.Nmos_vtl_C,       "nmos_vtl_C"        )
     lib.definePcell(Mosfet_vtl_C.Pmos_vtl_C,       "pmos_vtl_C"        )
     lib.definePcell(Mosfet_vtl_D.Nmos_vtl_D,       "nmos_vtl_D"        )
     lib.definePcell(Mosfet_vtl_D.Pmos_vtl_D,       "pmos_vtl_D"        )
     lib.definePcell(Mosfet_vtl_E.Nmos_vtl_E,       "nmos_vtl_E"        )
     lib.definePcell(Mosfet_vtl_E.Pmos_vtl_E,       "pmos_vtl_E"        )
     lib.definePcell(Mosfet_vtg.Nmos_vtg,       "nmos_vtg"        )
     lib.definePcell(Mosfet_vtg.Pmos_vtg,       "pmos_vtg"        )
     lib.definePcell(Mosfet_vtg_A.Nmos_vtg_A,       "nmos_vtg_A"        )
     lib.definePcell(Mosfet_vtg_A.Pmos_vtg_A,       "pmos_vtg_A"        )
     lib.definePcell(Mosfet_vtg_B.Nmos_vtg_B,       "nmos_vtg_B"        )
     lib.definePcell(Mosfet_vtg_B.Pmos_vtg_B,       "pmos_vtg_B"        )
     lib.definePcell(Mosfet_vtg_C.Nmos_vtg_C,       "nmos_vtg_C"        )
     lib.definePcell(Mosfet_vtg_C.Pmos_vtg_C,       "pmos_vtg_C"        )
     lib.definePcell(Mosfet_vtg_D.Nmos_vtg_D,       "nmos_vtg_D"        )
     lib.definePcell(Mosfet_vtg_D.Pmos_vtg_D,       "pmos_vtg_D"        )
     lib.definePcell(Mosfet_vtg_E.Nmos_vtg_E,       "nmos_vtg_E"        )
     lib.definePcell(Mosfet_vtg_E.Pmos_vtg_E,       "pmos_vtg_E"        )
     lib.definePcell(Mosfet_vth.Nmos_vth,       "nmos_vth"        )
     lib.definePcell(Mosfet_vth.Pmos_vth,       "pmos_vth"        )
     lib.definePcell(Mosfet_vth_A.Nmos_vth_A,       "nmos_vth_A"        )
     lib.definePcell(Mosfet_vth_A.Pmos_vth_A,       "pmos_vth_A"        )
     lib.definePcell(Mosfet_vth_B.Nmos_vth_B,       "nmos_vth_B"        )
     lib.definePcell(Mosfet_vth_B.Pmos_vth_B,       "pmos_vth_B"        )
     lib.definePcell(Mosfet_vth_C.Nmos_vth_C,       "nmos_vth_C"        )
     lib.definePcell(Mosfet_vth_C.Pmos_vth_C,       "pmos_vth_C"        )
     lib.definePcell(Mosfet_vth_D.Nmos_vth_D,       "nmos_vth_D"        )
     lib.definePcell(Mosfet_vth_D.Pmos_vth_D,       "pmos_vth_D"        )
     lib.definePcell(Mosfet_vth_E.Nmos_vth_E,       "nmos_vth_E"        )
     lib.definePcell(Mosfet_vth_E.Pmos_vth_E,       "pmos_vth_E"        )
     lib.definePcell(Mosfet_thkox.Nmos_thkox,       "nmos_thkox"      )
     lib.definePcell(Mosfet_thkox.Pmos_thkox,       "pmos_thkox"      )
     lib.definePcell(Mosfet_thkox_A.Nmos_thkox_A,       "nmos_thkox_A"      )
     lib.definePcell(Mosfet_thkox_A.Pmos_thkox_A,       "pmos_thkox_A"      )
     lib.definePcell(Mosfet_thkox_B.Nmos_thkox_B,       "nmos_thkox_B"      )
     lib.definePcell(Mosfet_thkox_B.Pmos_thkox_B,       "pmos_thkox_B"      )
     lib.definePcell(Mosfet_thkox_C.Nmos_thkox_C,       "nmos_thkox_C"        )
     lib.definePcell(Mosfet_thkox_C.Pmos_thkox_C,       "pmos_thkox_C"        )
     lib.definePcell(Mosfet_thkox_D.Nmos_thkox_D,       "nmos_thkox_D"        )
     lib.definePcell(Mosfet_thkox_D.Pmos_thkox_D,       "pmos_thkox_D"        )
     lib.definePcell(Mosfet_thkox_E.Nmos_thkox_E,       "nmos_thkox_E"        )
     lib.definePcell(Mosfet_thkox_E.Pmos_thkox_E,       "pmos_thkox_E"        )
#     lib.definePcell(transistorUnit.PyTransistorUnit,  "PyTransistor")
#     lib.definePcell(diffPair.PyDiffPair,        "PyDiffPair"  )
